import com.sun.star.lang.*;
import com.sun.star.comp.loader.FactoryHelper;
import com.sun.star.registry.XRegistryKey;
import com.sun.star.lib.uno.helper.WeakBase;
import com.sun.star.beans.XPropertySet;
import com.sun.star.sheet.XAddIn;
import jp.ac.kobe_u.cs.cream.uno.XCreamAddins;

public class CreamAddins {

    static public class _CreamAddins extends WeakBase
	implements XCreamAddins, XAddIn, XServiceName, XServiceInfo
    {
        
/** The component will be registered under this name.
 */
        static private final String __serviceName = "jp.ac.kobe_u.cs.cream.uno.CreamAddins";
        
        static private final String ADDIN_SERVICE = "com.sun.star.sheet.AddIn";
        
        private Locale aFuncLoc;
        
        private static final String[] stringFunctionName = {
/** TO DO:
 * You should replace these method names by the method names of your interface.
 */
            "CStart",
            "CNext",
            "CVAR",
            "CINT",
            "C",
            "CNOTEQUALS",
            "CSOLVE"
        };
        
        private static final short shortINVALID = -1;
        
/** TO DO:
 * For each of your methods you should make up a new constant with a different value.
 */
        private static final short shortCSTART = 0;
        private static final short shortCNEXT = 1;
        private static final short shortCVAR = 2;
        private static final short shortCINT = 3;
        private static final short shortC = 4;
        private static final short shortCNOTEQUALS = 5;
        private static final short shortCSOLVE = 6;
        
/** TO DO:
 * This is where you implement all methods of your interface. The parameters have to
 * be the same as in your IDL file and their types have to be the correct 
 * IDL-to-Java mappings of their types in the IDL file.
 */
        public boolean CStart(Object sheet) {
	    return CreamSolver.CStart(sheet);
        }

        public boolean CNext() {
	    return CreamSolver.CNext();
        }

        public int CVAR(XPropertySet xOptions, Object domain, int value) {
	    return CreamSolver.CVAR(xOptions, domain, value);
        }
        
        public Object CINT(XPropertySet xOptions, int inf, int sup) {
	    return CreamSolver.CINT(xOptions, inf, sup);
        }
        
        public Object C(XPropertySet xOptions, Object constraint) {
	    return CreamSolver.C(xOptions, constraint);
        }
        
        public Object CNOTEQUALS(XPropertySet xOptions, Object[] cells) {
	    return CreamSolver.CNOTEQUALS(xOptions, cells);
        }
        
        public Object CSOLVE(XPropertySet xOptions, Object[] constraints) {
	    return CreamSolver.CSOLVE(xOptions, constraints);
        }
        
        // Implement method from interface XServiceName
        public String getServiceName() {
            return( __serviceName );
        }
        
        // Implement methods from interface XServiceInfo
        public boolean supportsService(String stringServiceName) {
            return( stringServiceName.equals( ADDIN_SERVICE ) ||
                    stringServiceName.equals( __serviceName ) );
        }
        
        public String getImplementationName() {
            return( _CreamAddins.class.getName() );
        }
        
        public String[] getSupportedServiceNames() {
            String[] stringSupportedServiceNames = { ADDIN_SERVICE, __serviceName };
            return( stringSupportedServiceNames );
        }
        
        // Implement methods from interface XAddIn
        public String getDisplayArgumentName(String stringProgrammaticFunctionName, int intArgument) {
            String stringReturn = "";
            
            switch( this.getFunctionID( stringProgrammaticFunctionName ) ) {
/** TO DO:
 * You should list all argument names for each of your methods, here.
 */
                case shortCSTART:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                    }
                    break;
                case shortCNEXT:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                    }
                    break;
                case shortCVAR:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Domain";
                            break;
                        case 2:
                            stringReturn = "Value";
                            break;
                    }
                    break;
                case shortCINT:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Inf";
                        case 2:
                            stringReturn = "Sup";
                            break;
                    }
                    break;
                case shortC:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Constraint";
                            break;
                    }
                    break;
                case shortCNOTEQUALS:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Range";
                            break;
                    }
                    break;
                case shortCSOLVE:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Constraints";
                            break;
                    }
                    break;
            }
            return( stringReturn );
        }
        
        public String getDisplayFunctionName(String stringProgrammaticName) {
            String stringReturn = "";
            
            switch( this.getFunctionID( stringProgrammaticName ) ) {
/** TO DO:
 * Assign the name of each of your methods.
 */
                case shortCSTART:
                    stringReturn = "CStart";
                    break;
                case shortCNEXT:
                    stringReturn = "CNext";
                    break;
                case shortCVAR:
                    stringReturn = "CVAR";
                    break;
                case shortCINT:
                    stringReturn = "CINT";
                    break;
                case shortC:
                    stringReturn = "C";
                    break;
                case shortCNOTEQUALS:
                    stringReturn = "CNOTEQUALS";
                    break;
                case shortCSOLVE:
                    stringReturn = "CSOLVE";
                    break;
            }
            
            return( stringReturn );
        }
        
        public String getProgrammaticCategoryName(String p1) {
            return( "Add-In" );
        }
        
        public String getDisplayCategoryName(String p1) {
            return( "Add-In" );
        }
        
        public String getFunctionDescription(String stringProgrammaticName) {
            String stringReturn = "";
            
            switch( this.getFunctionID( stringProgrammaticName ) ) {
/** TO DO:
 * Enter a description for each of your methods that office users will understand.
 */
                case shortCSTART:
                    stringReturn = "This is CStart method.";
                    break;
                case shortCNEXT:
                    stringReturn = "This is CNext method.";
                    break;
                case shortCVAR:
                    stringReturn = "This is CVAR method.";
                    break;
                case shortCINT:
                    stringReturn = "This is CINT method.";
                    break;
                case shortC:
                    stringReturn = "This is C method.";
                    break;
                case shortCNOTEQUALS:
                    stringReturn = "This is CNOTEQUALS method.";
                    break;
                case shortCSOLVE:
                    stringReturn = "This is CSOLVE method.";
                    break;
            }
            
            return( stringReturn );
        }
        
        public String getArgumentDescription(String stringProgrammaticFunctionName,int intArgument) {
            String stringReturn = "";
            
            switch( this.getFunctionID( stringProgrammaticFunctionName ) ) {
/** TO DO:
 * Enter a description for every argument of every method. Make them so that office users will understand.
 */
                case shortCSTART:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                    }
                    break;
                case shortCNEXT:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                    }
                    break;
                case shortCVAR:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Initial domain of the variable.";
                            break;
                        case 2:
                            stringReturn = "Value of the variable.";
                            break;
                    }
                    break;
                case shortCINT:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Inf value of the domain.";
                            break;
                        case 2:
                            stringReturn = "Sup value of the domain.";
                            break;
                    }
                    break;
                case shortC:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "You can describe constraint.";
                            break;
                    }
                    break;
                case shortCNOTEQUALS:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "NOTEQUALS constraint.";
                            break;
                    }
                    break;
                case shortCSOLVE:
                    switch( intArgument ) {
                        case 0:
                            stringReturn = "(internal)";
                            break;
                        case 1:
                            stringReturn = "Constraints.";
                            break;
                    }
                    break;
            }
            return( stringReturn );
        }
        
        public String getProgrammaticFuntionName(String p1) {
            return( "" );
        }
        
        // Implement methods from interface XLocalizable
        public Locale getLocale() {
            return( aFuncLoc );
        }
        
        public void setLocale(Locale p1) {
            aFuncLoc = p1;
        }
        
        // Auxiliary functions
        private short getFunctionID( String stringProgrammaticName ) {
            for ( int i = 0; i < stringFunctionName.length; i++ ) {
                if ( stringProgrammaticName.equals( stringFunctionName[ i ] ) ) {
                    return( ( short ) i );
                }
            }
            
            return( -1 );
        }
    }
    
    /**
     * Returns a factory for creating the service.
     * This method is called by the <code>JavaLoader</code>
     * <p>
     * @return  returns a <code>XSingleServiceFactory</code> for creating the component
     * @param   implName     the name of the implementation for which a service is desired
     * @param   multiFactory the service manager to be used if needed
     * @param   regKey       the registryKey
     * @see                  com.sun.star.comp.loader.JavaLoader
     */
    public static XSingleServiceFactory __getServiceFactory(String implName,
    XMultiServiceFactory multiFactory,
    XRegistryKey regKey) {
        XSingleServiceFactory xSingleServiceFactory = null;
        
        if (implName.equals(_CreamAddins.class.getName()) )
            xSingleServiceFactory = FactoryHelper.getServiceFactory(_CreamAddins.class,
            _CreamAddins.__serviceName,
            multiFactory,
            regKey);
        
        return xSingleServiceFactory;
    }
    
    /**
     * Writes the service information into the given registry key.
     * This method is called by the <code>JavaLoader</code>
     * <p>
     * @return  returns true if the operation succeeded
     * @param   regKey       the registryKey
     * @see                  com.sun.star.comp.loader.JavaLoader
     */
    public static boolean __writeRegistryServiceInfo(XRegistryKey regKey) {
        return FactoryHelper.writeRegistryServiceInfo(_CreamAddins.class.getName(),
        _CreamAddins.__serviceName, regKey)
        && FactoryHelper.writeRegistryServiceInfo(_CreamAddins.class.getName(),
        _CreamAddins.ADDIN_SERVICE, regKey);
    }

}
